import 'dart:developer';

import 'package:flutter/material.dart';

class ValidationCheck {
  static String? validateEmail(String? value) {
    String pattern =
        r'^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$';
    // String pattern = r'^((/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$))$';
    RegExp regExp = RegExp(pattern);
    if (value == null || value.isEmpty) {
      return "Email is Required";
    } else if (!regExp.hasMatch(value)) {
      return "Invalid Email";
    } else {
      return null;
    }
  }

  static String? validatePasswordForSingUp(String value) {
    String pattern =
        r'^.*(?=.{8,})((?=.*[!@#$%^&*()\-_=+{};:,<.>]){1})(?=.*\d)((?=.*[a-z]){1})((?=.*[A-Z]){1}).*$';
    RegExp regExp = RegExp(pattern);
    if (value.isEmpty) {
      return "Password is Required";
    } else if (!regExp.hasMatch(value)) {
      return "The password must be at least 8 characters long and contain a mixture of both uppercase and lowercase letters, at least one number and one special character (e.g.,! @ # ?).";
    } else {
      return null;
    }
  }

  static String? validatePasswordLogIN(String value) {
    String pattern =
        r'^.*(?=.{8,})((?=.*[!@#$%^&*()\-_=+{};:,<.>]){1})(?=.*\d)((?=.*[a-z]){1})((?=.*[A-Z]){1}).*$';
    RegExp regExp = RegExp(pattern);
    if (value.isEmpty) {
      return "Password is Required";
    } else if (!regExp.hasMatch(value)) {
      return "Please enter a valid Password";
    } else {
      return null;
    }
  }

  static String? validateConfirmPassword(String value, String password) {
    String pattern =
        r'^.*(?=.{8,})((?=.*[!@#$%^&*()\-_=+{};:,<.>]){1})(?=.*\d)((?=.*[a-z]){1})((?=.*[A-Z]){1}).*$';
    RegExp regExp = RegExp(pattern);
    if (value.isEmpty) {
      return "Confirm Password is Required";
    } else if (!regExp.hasMatch(value)) {
      return "The password must be at least 8 characters long and contain a mixture of both uppercase and lowercase letters, at least one number and one special character (e.g.,! @ # ?).";
    } else if (value != password) {
      return "Confirm password should be match with password";
    } else {
      return null;
    }
  }

  bool? isValidateorNot(GlobalKey<FormState> formKey) {
    if (formKey.currentState!.validate()) {
      log("YOUR VALIDATION IS CORRECT");
      return true;
    }
    log("YOUR VALIDATION IS NOT CORRECT");
    return false;
  }
}
